hdu 1011 Starship Troopers dp 带点坑的树形背包 ★



Starship Troopers

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 17034    Accepted Submission(s): 4509


Problem Description
You, the leader of Starship Troopers, are sent to destroy a base of the bugs. The base is built underground. It is actually a huge cavern, which consists of many rooms connected with tunnels. Each room is occupied by some bugs, and their brains hide in some of the rooms. Scientists have just developed a new weapon and want to experiment it on some brains. Your task is to destroy the whole base, and capture as many brains as possible.

To kill all the bugs is always easier than to capture their brains. A map is drawn for you, with all the rooms marked by the amount of bugs inside, and the possibility of containing a brain. The cavern's structure is like a tree in such a way that there is one unique path leading to each room from the entrance. To finish the battle as soon as possible, you do not want to wait for the troopers to clear a room before advancing to the next one, instead you have to leave some troopers at each room passed to fight all the bugs inside. The troopers never re-enter a room where they have visited before.

A starship trooper can fight against 20 bugs. Since you do not have enough troopers, you can only take some of the rooms and let the nerve gas do the rest of the job. At the mean time, you should maximize the possibility of capturing a brain. To simplify the problem, just maximize the sum of all the possibilities of containing brains for the taken rooms. Making such a plan is a difficult job. You need the help of a computer.
 

Input
The input contains several test cases. The first line of each test case contains two integers N (0 < N <= 100) and M (0 <= M <= 100), which are the number of rooms in the cavern and the number of starship troopers you have, respectively. The following N lines give the description of the rooms. Each line contains two non-negative integers -- the amount of bugs inside and the possibility of containing a brain, respectively. The next N - 1 lines give the description of tunnels. Each tunnel is described by two integers, which are the indices of the two rooms it connects. Rooms are numbered from 1 and room 1 is the entrance to the cavern.

The last test case is followed by two -1's.
 

Output
For each test case, print on a single line the maximum sum of all the possibilities of containing brains for the taken rooms.
 

Sample Input
  
  
5 10 50 10 40 10 40 20 65 30 70 30 1 2 1 3 2 4 2 5 1 1 20 7 -1 -1
 

Sample Output
  
  
50 7
 

Author
XU, Chuan
 

Source
 

Recommend
JGShining   |   We have carefully selected several similar problems for you:   1203  2415  2159  3449  1171 
 

Statistic |  Submit |  Discuss |  Note

   题意:

 一个基地中有n个房间,基地为一棵树结构,每个房间中都有一些bug,和brain,

现在有m个士兵,每个士兵,可以抵抗20个bug,现在需要获得尽量多的brain,输出最大值。

基地入口是房间1。只有攻破前一个房间(可以抵抗该房间所有bug)才可以到达下一个房间,一个士兵不能两次到达相同的房间。为了加快时间,可以先把士兵放在一个房间里,抵抗bug,其余士兵到后面的房间。


坑点:题意描述含糊难懂,

         如果一个房间里面没有bug,但要想去取得里面的brain,必须派兵过去,而且他不能回来。

         dp[x][v]的含义一般是攻破房间x后,士兵数为v,子树x最多能获得的brain数。

        所以如果m==0,直接输出0,因为就算房间1没有bug,也无法取得brain。


解法:树形背包


#include<cstdio>
#include<string>
#include<cstring>
#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define for0(a, n) for (int (a) = 0; (a) < (n); (a)++)
#define for1(a, n) for (int (a) = 1; (a) <= (n); (a)++)
typedef long long ll;
typedef pair<int, int> pii;
const int maxn= 100   ;
int n,m,nedge;
int nbug[maxn+1],nbrain[maxn+1];

int fir[maxn+1],nex[2*maxn],to[2*maxn];
int edges[2*maxn];
int dp[maxn+1][maxn+1];
inline void add_edge(int x,int y)
{
    to[nedge]=y;
    nex[nedge]=fir[x];
    fir[x]=nedge++;

}
void init()
{
    memset(fir,-1,(n+1)*sizeof fir[0]);
    nedge=0;
}

int update(int &x,int y)
{
    if(y>x)  x=y;
}
void dfs(int x,int fa)
{
    for0(i,nbug[x])  dp[x][i]=0;
    for(int i=nbug[x];i<=m;i++)  dp[x][i]=nbrain[x]  ;
    for(int i=fir[x];~i;i=nex[i])
    {
        int y=to[i];if(y==fa) continue;
        dfs(y,x);
        for(int v=m;v>=max(1,nbug[y]);v--)
        {
            int ret=dp[x][v];
            for(int v2=max(1,nbug[y]);v2<=v;v2++) if(v-v2>=nbug[x])
            {
                update(ret,dp[x][v-v2]+dp[y][v2]);
            }
            dp[x][v]=ret;
        }
    }

}
int main()
{
     std::ios::sync_with_stdio(false);
    while(cin>>n>>m )
    {

        if(n==-1&&m==-1)  break;
        init();
        for1(i,n)
        {
          cin>>nbug[i]>>nbrain[i];
          nbug[i]= (nbug[i]+19)/20;
        }

        int x,y;
        for1(i,n-1)
        {
            cin>>x>>y;
            add_edge(x,y);
            add_edge(y,x);
        }
         if(m==0) {puts("0");continue;}
        dfs(1,-1);
        printf("%d\n",dp[1][m]);
    }

   return 0;
}



/*
5 10
50 10
40 10
40 20
65 30
70 30
1 2
1 3
2 4
2 5

ans=50

5 2
0 1
0 1
0 5
0 1
0 2
1 2
1 3
2 4
2 5

ans=9;

3 0
0 10
0 10
0 10
1 2
1 3

ans=0;
*/



  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值